#ifndef __CLASS_MMCONTROL_HEADER_INCLUDED__
#define __CLASS_MMCONTROL_HEADER_INCLUDED__
#include <windows.h>
#include <mmsystem.h>

class cMMControl {

 public:

   enum eTFDestination  {
      dstDigital     =   MIXERLINE_COMPONENTTYPE_DST_DIGITAL,
      dstHeadphone   =   MIXERLINE_COMPONENTTYPE_DST_HEADPHONES,
      dstLine        =   MIXERLINE_COMPONENTTYPE_DST_LINE,
      dstMonitor     =   MIXERLINE_COMPONENTTYPE_DST_MONITOR,
      dstSpeakers    =   MIXERLINE_COMPONENTTYPE_DST_SPEAKERS,
      dstTelephone   =   MIXERLINE_COMPONENTTYPE_DST_TELEPHONE,
      dstVoicein     =   MIXERLINE_COMPONENTTYPE_DST_VOICEIN,
      dstWavein      =   MIXERLINE_COMPONENTTYPE_DST_WAVEIN,
      } dst;

   enum eTFSource {
      srcAnalog      =  MIXERLINE_COMPONENTTYPE_SRC_ANALOG,
      srcAuxilary    =  MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY,
      srcCompactdisk =  MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC,
      srcDigital     =  MIXERLINE_COMPONENTTYPE_SRC_DIGITAL,
      srcLine        =  MIXERLINE_COMPONENTTYPE_SRC_LINE,
      srcMicrophone  =  MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE,
      srcPcspeaker   =  MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER,
      srcSythesizer  =  MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER,
      srcTelephone   =  MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE,
      srcWaveout     =  MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT,
      srcNone        =  MIXERLINE_COMPONENTTYPE_SRC_LAST +1
      } src;

   enum  eTFFader {
      fdBass         =  MIXERCONTROL_CONTROLTYPE_BASS,
      fdFader        =  MIXERCONTROL_CONTROLTYPE_FADER,
      fdTreble       =  MIXERCONTROL_CONTROLTYPE_TREBLE,
      fdVolume       =  MIXERCONTROL_CONTROLTYPE_VOLUME,
      fdPan          =  MIXERCONTROL_CONTROLTYPE_PAN
      } fd;

   enum eTFSwitch {
      swLoudness     =  MIXERCONTROL_CONTROLTYPE_LOUDNESS,
      swMono         =  MIXERCONTROL_CONTROLTYPE_MONO,
      swMute         =  MIXERCONTROL_CONTROLTYPE_MUTE,
      swOnoff        =  MIXERCONTROL_CONTROLTYPE_ONOFF,
      swStereoenh    =  MIXERCONTROL_CONTROLTYPE_STEREOENH
      } sw;

   typedef enum eTFDestination   tDestination;
   typedef enum eTFSource        tSource;
   typedef enum eTFFader         tFader;
   typedef enum eTFSwitch        tSwitch;

 public:

   cMMControl (void);
  ~cMMControl (void);

   bool  Open            (tSource,tDestination,tFader,tSwitch);
   bool  Switch          (bool enable);
   bool  Fade            (UINT percent);
   void  Reset           (void);

 private:

   HMIXEROBJ            hMixer;
   MIXERCONTROL        *mcSwitch;
   MIXERCONTROL        *mcFader;

   bool GetDestination  (UINT &id,UINT &n,tDestination dst);
   bool GetSource       (UINT &id,UINT &n,tSource src);
   bool GetControls     (UINT id,UINT n,tSwitch sw,tFader fd);

   MIXERCONTROLDETAILS_BOOLEAN   mdSwitch;
   MIXERCONTROLDETAILS_UNSIGNED  mdFader;
};

#endif // (__CLASS_MMCONTROL_HEADER_INCLUDED__)
